#!/bin/bash

if [ "$#" -lt 2 ]
then
    echo "Usage: Verify.bash MESSAGE SIGNATURE_FILE"
    exit
fi

if [ ! -e $2 ]
then
    echo "Signature file $2 does not exists" 
    exit
fi

# recover the hash from the signed message
signed_hash=$(openssl rsautl -verify -inkey public.pem -pubin -in $2)

# recomputes the hash
hash=$(echo -n  $1 | sha256sum | cut -c 1-12)

if [ $hash = $signed_hash ]
then
    echo "Valid signature!"
else
    echo "Wrong signature, sorry!"
fi

